diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/ctrl-headers.cc ns-3.43/src/wifi/model/ctrl-headers.cc
--- ns-3.42/src/wifi/model/ctrl-headers.cc	2024-05-29 15:29:47.196073800 -0700
+++ ns-3.43/src/wifi/model/ctrl-headers.cc	2024-10-09 16:41:10.116656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2009 MIRKO BANCHI
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Mirko Banchi <mk.banchi@gmail.com>
  */
@@ -1696,8 +1685,8 @@
     m_triggerType = type;
     SetUlBandwidth(txVector.GetChannelWidth());
     SetUlLength(txVector.GetLength());
-    uint16_t gi = txVector.GetGuardInterval();
-    if (gi == 800 || gi == 1600)
+    const auto gi = txVector.GetGuardInterval().GetNanoSeconds();
+    if ((gi == 800) || (gi == 1600))
     {
         m_giAndLtfType = 1;
     }
@@ -2038,9 +2027,9 @@
 }
 
 void
-CtrlTriggerHeader::SetUlBandwidth(uint16_t bw)
+CtrlTriggerHeader::SetUlBandwidth(MHz_u bw)
 {
-    switch (bw)
+    switch (static_cast<uint16_t>(bw))
     {
     case 20:
         m_ulBandwidth = 0;
@@ -2060,24 +2049,25 @@
     }
 }
 
-uint16_t
+MHz_u
 CtrlTriggerHeader::GetUlBandwidth() const
 {
     return (1 << m_ulBandwidth) * 20;
 }
 
 void
-CtrlTriggerHeader::SetGiAndLtfType(uint16_t guardInterval, uint8_t ltfType)
+CtrlTriggerHeader::SetGiAndLtfType(Time guardInterval, uint8_t ltfType)
 {
-    if (ltfType == 1 && guardInterval == 1600)
+    const auto gi = guardInterval.GetNanoSeconds();
+    if ((ltfType == 1) && (gi == 1600))
     {
         m_giAndLtfType = 0;
     }
-    else if (ltfType == 2 && guardInterval == 1600)
+    else if ((ltfType == 2) && (gi == 1600))
     {
         m_giAndLtfType = 1;
     }
-    else if (ltfType == 4 && guardInterval == 3200)
+    else if ((ltfType == 4) && (gi == 3200))
     {
         m_giAndLtfType = 2;
     }
@@ -2087,16 +2077,16 @@
     }
 }
 
-uint16_t
+Time
 CtrlTriggerHeader::GetGuardInterval() const
 {
     if (m_giAndLtfType == 0 || m_giAndLtfType == 1)
     {
-        return 1600;
+        return NanoSeconds(1600);
     }
     else if (m_giAndLtfType == 2)
     {
-        return 3200;
+        return NanoSeconds(3200);
     }
     else
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/ctrl-headers.h ns-3.43/src/wifi/model/ctrl-headers.h
--- ns-3.42/src/wifi/model/ctrl-headers.h	2024-05-29 15:29:47.196073800 -0700
+++ ns-3.43/src/wifi/model/ctrl-headers.h	2024-10-09 16:41:10.116656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2009 MIRKO BANCHI
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Mirko Banchi <mk.banchi@gmail.com>
  */
@@ -1128,13 +1117,13 @@
      *
      * \param bw bandwidth (allowed values: 20, 40, 80, 160)
      */
-    void SetUlBandwidth(uint16_t bw);
+    void SetUlBandwidth(MHz_u bw);
     /**
      * Get the bandwidth of the solicited HE TB PPDU.
      *
      * \return the bandwidth (20, 40, 80 or 160)
      */
-    uint16_t GetUlBandwidth() const;
+    MHz_u GetUlBandwidth() const;
     /**
      * Set the GI And LTF Type subfield of the Common Info field.
      * Allowed combinations are:
@@ -1142,16 +1131,16 @@
      *   - 2x LTF + 1.6us GI
      *   - 4x LTF + 3.2us GI
      *
-     * \param guardInterval the guard interval duration (in nanoseconds)
+     * \param guardInterval the guard interval duration
      * \param ltfType the HE-LTF type (1, 2 or 4)
      */
-    void SetGiAndLtfType(uint16_t guardInterval, uint8_t ltfType);
+    void SetGiAndLtfType(Time guardInterval, uint8_t ltfType);
     /**
-     * Get the guard interval duration (in nanoseconds) of the solicited HE TB PPDU.
+     * Get the guard interval duration of the solicited HE TB PPDU.
      *
-     * \return the guard interval duration (in nanoseconds) of the solicited HE TB PPDU
+     * \return the guard interval duration  of the solicited HE TB PPDU
      */
-    uint16_t GetGuardInterval() const;
+    Time GetGuardInterval() const;
     /**
      * Get the LTF type of the solicited HE TB PPDU.
      *
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/edca-parameter-set.cc ns-3.43/src/wifi/model/edca-parameter-set.cc
--- ns-3.42/src/wifi/model/edca-parameter-set.cc	2024-05-29 15:29:47.196073800 -0700
+++ ns-3.43/src/wifi/model/edca-parameter-set.cc	2024-10-09 16:41:10.116656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2016 Sébastien Deronne
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/edca-parameter-set.h ns-3.43/src/wifi/model/edca-parameter-set.h
--- ns-3.42/src/wifi/model/edca-parameter-set.h	2024-05-29 15:29:47.196073800 -0700
+++ ns-3.43/src/wifi/model/edca-parameter-set.h	2024-10-09 16:41:10.116656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2016 Sébastien Deronne
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/eht/advanced-ap-emlsr-manager.cc ns-3.43/src/wifi/model/eht/advanced-ap-emlsr-manager.cc
--- ns-3.42/src/wifi/model/eht/advanced-ap-emlsr-manager.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.43/src/wifi/model/eht/advanced-ap-emlsr-manager.cc	2024-10-09 16:41:10.116656800 -0700
@@ -0,0 +1,198 @@
+/*
+ * Copyright (c) 2024 Universita' di Napoli Federico II
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Author: Stefano Avallone <stavallo@unina.it>
+ */
+
+#include "advanced-ap-emlsr-manager.h"
+
+#include "eht-frame-exchange-manager.h"
+
+#include "ns3/ap-wifi-mac.h"
+#include "ns3/boolean.h"
+#include "ns3/log.h"
+#include "ns3/wifi-phy.h"
+#include "ns3/wifi-psdu.h"
+
+namespace ns3
+{
+
+NS_LOG_COMPONENT_DEFINE("AdvancedApEmlsrManager");
+
+NS_OBJECT_ENSURE_REGISTERED(AdvancedApEmlsrManager);
+
+TypeId
+AdvancedApEmlsrManager::GetTypeId()
+{
+    static TypeId tid =
+        TypeId("ns3::AdvancedApEmlsrManager")
+            .SetParent<DefaultApEmlsrManager>()
+            .SetGroupName("Wifi")
+            .AddConstructor<AdvancedApEmlsrManager>()
+            .AddAttribute("UseNotifiedMacHdr",
+                          "Whether to use the information about the MAC header of the MPDU "
+                          "being received, if notified by the PHY.",
+                          BooleanValue(true),
+                          MakeBooleanAccessor(&AdvancedApEmlsrManager::m_useNotifiedMacHdr),
+                          MakeBooleanChecker())
+            .AddAttribute("EarlySwitchToListening",
+                          "Whether the AP MLD assumes that an EMLSR client is able to detect at "
+                          "the end of the MAC header that a PSDU is not addressed to it and "
+                          "immediately starts switching to listening mode.",
+                          BooleanValue(false),
+                          MakeBooleanAccessor(&AdvancedApEmlsrManager::m_earlySwitchToListening),
+                          MakeBooleanChecker())
+            .AddAttribute(
+                "WaitTransDelayOnPsduRxError",
+                "If true, the AP MLD waits for a response timeout after a PSDU reception "
+                "error before starting the transition delay for the EMLSR client that "
+                "sent the failed PSDU. Otherwise, the AP MLD does not start the "
+                "transition delay timer for the EMLSR client that sent the failed PSDU.",
+                BooleanValue(true),
+                MakeBooleanAccessor(&AdvancedApEmlsrManager::m_waitTransDelayOnPsduRxError),
+                MakeBooleanChecker())
+            .AddAttribute("UpdateCwAfterFailedIcf",
+                          "Whether the AP MLD shall double the CW upon CTS timeout after an "
+                          "MU-RTS in case all the clients solicited by the MU-RTS are EMLSR "
+                          "clients that have sent (or are sending) a frame to the AP",
+                          BooleanValue(true),
+                          MakeBooleanAccessor(&AdvancedApEmlsrManager::m_updateCwAfterFailedIcf),
+                          MakeBooleanChecker());
+    return tid;
+}
+
+AdvancedApEmlsrManager::AdvancedApEmlsrManager()
+{
+    NS_LOG_FUNCTION(this);
+}
+
+AdvancedApEmlsrManager::~AdvancedApEmlsrManager()
+{
+    NS_LOG_FUNCTION_NOARGS();
+}
+
+void
+AdvancedApEmlsrManager::DoDispose()
+{
+    NS_LOG_FUNCTION(this);
+    for (uint8_t linkId = 0; linkId < GetApMac()->GetNLinks(); linkId++)
+    {
+        auto phy = GetApMac()->GetWifiPhy(linkId);
+        phy->TraceDisconnectWithoutContext(
+            "PhyRxMacHeaderEnd",
+            MakeCallback(&AdvancedApEmlsrManager::ReceivedMacHdr, this).Bind(linkId));
+    }
+    DefaultApEmlsrManager::DoDispose();
+}
+
+void
+AdvancedApEmlsrManager::DoSetWifiMac(Ptr<ApWifiMac> mac)
+{
+    NS_LOG_FUNCTION(this << mac);
+
+    for (uint8_t linkId = 0; linkId < GetApMac()->GetNLinks(); linkId++)
+    {
+        auto phy = GetApMac()->GetWifiPhy(linkId);
+        phy->TraceConnectWithoutContext(
+            "PhyRxMacHeaderEnd",
+            MakeCallback(&AdvancedApEmlsrManager::ReceivedMacHdr, this).Bind(linkId));
+    }
+}
+
+void
+AdvancedApEmlsrManager::ReceivedMacHdr(uint8_t linkId,
+                                       const WifiMacHeader& macHdr,
+                                       const WifiTxVector& txVector,
+                                       Time psduDuration)
+{
+    NS_LOG_FUNCTION(this << linkId << macHdr << txVector << psduDuration.As(Time::MS));
+
+    if (m_useNotifiedMacHdr && GetEhtFem(linkId)->CheckEmlsrClientStartingTxop(macHdr, txVector))
+    {
+        // the AP MLD is receiving an MPDU from an EMLSR client that is starting an UL TXOP.
+        // CheckEmlsrClientStartingTxop has blocked transmissions to the EMLSR client on other
+        // links. If the reception of the PSDU fails, however, the AP MLD does not respond and
+        // the EMLSR client will switch to listening mode after the ack timeout.
+        m_blockedLinksOnMacHdrRx.insert(linkId);
+    }
+}
+
+void
+AdvancedApEmlsrManager::NotifyPsduRxOk(uint8_t linkId, Ptr<const WifiPsdu> psdu)
+{
+    NS_LOG_FUNCTION(this << linkId << *psdu);
+    m_blockedLinksOnMacHdrRx.erase(linkId);
+}
+
+void
+AdvancedApEmlsrManager::NotifyPsduRxError(uint8_t linkId, Ptr<const WifiPsdu> psdu)
+{
+    NS_LOG_FUNCTION(this << linkId << *psdu);
+
+    if (auto it = m_blockedLinksOnMacHdrRx.find(linkId); it == m_blockedLinksOnMacHdrRx.cend())
+    {
+        return;
+    }
+    else
+    {
+        m_blockedLinksOnMacHdrRx.erase(it);
+    }
+
+    if (m_waitTransDelayOnPsduRxError)
+    {
+        auto phy = GetApMac()->GetWifiPhy(linkId);
+        auto delay = phy->GetSifs() + phy->GetSlot() + EMLSR_RX_PHY_START_DELAY;
+        GetEhtFem(linkId)->EmlsrSwitchToListening(psdu->GetAddr2(), delay);
+        return;
+    }
+
+    // all other EMLSR links were blocked when receiving MAC header; unblock them now
+    auto mldAddress =
+        GetApMac()->GetWifiRemoteStationManager(linkId)->GetMldAddress(psdu->GetAddr2());
+    if (!mldAddress.has_value())
+    {
+        NS_LOG_DEBUG(psdu->GetAddr2() << " is not an EMLSR client");
+        return;
+    }
+
+    std::set<uint8_t> linkIds;
+    for (uint8_t id = 0; id < GetApMac()->GetNLinks(); id++)
+    {
+        if (GetApMac()->GetWifiRemoteStationManager(id)->GetEmlsrEnabled(*mldAddress))
+        {
+            linkIds.insert(id);
+        }
+    }
+    GetApMac()->UnblockUnicastTxOnLinks(WifiQueueBlockedReason::USING_OTHER_EMLSR_LINK,
+                                        *mldAddress,
+                                        linkIds);
+}
+
+Time
+AdvancedApEmlsrManager::GetDelayOnTxPsduNotForEmlsr(Ptr<const WifiPsdu> psdu,
+                                                    const WifiTxVector& txVector,
+                                                    WifiPhyBand band)
+{
+    NS_LOG_FUNCTION(this << psdu << txVector << band);
+
+    if (!m_earlySwitchToListening)
+    {
+        return DefaultApEmlsrManager::GetDelayOnTxPsduNotForEmlsr(psdu, txVector, band);
+    }
+
+    // EMLSR clients switch back to listening operation at the end of MAC header RX
+    auto macHdrSize = (*psdu->begin())->GetHeader().GetSerializedSize() +
+                      ((psdu->GetNMpdus() > 1 || psdu->IsSingle()) ? 4 : 0);
+    // return the duration of the MAC header TX
+    return DataRate(txVector.GetMode().GetDataRate(txVector)).CalculateBytesTxTime(macHdrSize);
+}
+
+bool
+AdvancedApEmlsrManager::UpdateCwAfterFailedIcf()
+{
+    return m_updateCwAfterFailedIcf;
+}
+
+} // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/eht/advanced-ap-emlsr-manager.h ns-3.43/src/wifi/model/eht/advanced-ap-emlsr-manager.h
--- ns-3.42/src/wifi/model/eht/advanced-ap-emlsr-manager.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.43/src/wifi/model/eht/advanced-ap-emlsr-manager.h	2024-10-09 16:41:10.116656800 -0700
@@ -0,0 +1,86 @@
+/*
+ * Copyright (c) 2024 Universita' di Napoli Federico II
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Author: Stefano Avallone <stavallo@unina.it>
+ */
+
+#ifndef ADVANCED_AP_EMLSR_MANAGER_H
+#define ADVANCED_AP_EMLSR_MANAGER_H
+
+#include "default-ap-emlsr-manager.h"
+
+#include "ns3/nstime.h"
+
+#include <set>
+
+namespace ns3
+{
+
+class ApWifiMac;
+class WifiMacHeader;
+class WifiPsdu;
+class WifiTxVector;
+
+/**
+ * \ingroup wifi
+ *
+ * AdvancedApEmlsrManager is an advanced AP EMLSR manager.
+ */
+class AdvancedApEmlsrManager : public DefaultApEmlsrManager
+{
+  public:
+    /**
+     * \brief Get the type ID.
+     * \return the object TypeId
+     */
+    static TypeId GetTypeId();
+
+    AdvancedApEmlsrManager();
+    ~AdvancedApEmlsrManager() override;
+
+    void NotifyPsduRxOk(uint8_t linkId, Ptr<const WifiPsdu> psdu) override;
+    void NotifyPsduRxError(uint8_t linkId, Ptr<const WifiPsdu> psdu) override;
+    Time GetDelayOnTxPsduNotForEmlsr(Ptr<const WifiPsdu> psdu,
+                                     const WifiTxVector& txVector,
+                                     WifiPhyBand band) override;
+    bool UpdateCwAfterFailedIcf() override;
+
+  protected:
+    void DoDispose() override;
+    void DoSetWifiMac(Ptr<ApWifiMac> mac) override;
+
+    /**
+     * Store information about the MAC header of the MPDU being received on the given link.
+     *
+     * \param linkId the ID of the given link
+     * \param macHdr the MAC header of the MPDU being received
+     * \param txVector the TXVECTOR used to transmit the PSDU
+     * \param psduDuration the remaining duration of the PSDU
+     */
+    void ReceivedMacHdr(uint8_t linkId,
+                        const WifiMacHeader& macHdr,
+                        const WifiTxVector& txVector,
+                        Time psduDuration);
+
+  private:
+    std::set<uint8_t>
+        m_blockedLinksOnMacHdrRx;  //!< links that have been blocked upon receiving a MAC header
+    bool m_useNotifiedMacHdr;      //!< whether to use the information about the MAC header of
+                                   //!< the MPDU being received (if notified by the PHY)
+    bool m_earlySwitchToListening; //!< Whether the AP MLD assumes that an EMLSR client is able to
+                                   //!< detect at the end of the MAC header that a PSDU is not
+                                   //!< addressed to it and immediately starts switching to
+                                   //!< listening mode
+    bool m_waitTransDelayOnPsduRxError; //!< Whether the AP MLD waits for a response timeout after a
+                                        //!< PSDU reception error before starting the transition
+                                        //!< delay
+    bool m_updateCwAfterFailedIcf;      //!< Whether the AP MLD shall double the CW upon CTS timeout
+                                   //!< after an MU-RTS in case all the clients solicited by the
+                                   //!< MU-RTS are EMLSR clients that have sent a frame to the AP
+};
+
+} // namespace ns3
+
+#endif /* ADVANCED_AP_EMLSR_MANAGER_H */
